﻿using LiquidacionGastos.Models;
using LiquidacionGastos.Repositories;
using LiquidacionGastos.Security;
using LiquidacionGastos.UnitsOfWork;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Transactions;

namespace LiquidacionGastos.Business
{
    public class MasterTypeManagement
    {
        public MasterTypeManagement()
        {
        }

        public void CreateMasterTypes()
        {
            using (MasterTypeUnitOfWork uow = new MasterTypeUnitOfWork())
            {
                UsuarioRepository usuarioRepository = new UsuarioRepository(uow.Context);
                Usuario usuario = usuarioRepository.GetUsuarioByIdentificador("administrador");

                if (usuario == null)
                {
                    usuario = usuarioRepository.CreateUsuario();
                    usuario.Nombre = "Administrador";
                    usuario.EsAdministrador = true;
                    usuario.EstaActivadoLogin = true;
                    usuario.EstaActivadoNotificarPorEmail = false;
                    usuario.Identificador = "administrador";
                    usuario.HashContrasena = PasswordHash.CreateHash("a");
                    usuarioRepository.InsertUsuario(usuario);
                }

                uow.CreateMasterTypes();
                uow.Commit();
            }

            using (UsuarioUnitOfWork uow = new UsuarioUnitOfWork())
            {
                
            }
        }        
    }
}

