using LiquidacionGastos.Framework;
using System;
using System.Collections.Generic;

namespace LiquidacionGastos.Models
{
    public partial class Calendario : ObservableObject
    {
        public Calendario()
        {
            this.Liquidaciones = new List<Liquidacion>();
            //this.Usuarios = new List<Usuario>();
        }

        // Identificador del usuario.
        private System.Guid _IdCalendario;
        public System.Guid IdCalendario { get { return _IdCalendario; } set { _IdCalendario = value; OnPropertyChanged(); } }

        // Nombre completo del usuario.
        private string _Nombre;
        public string Nombre { get { return _Nombre; } set { _Nombre = value; OnPropertyChanged(); } }

        // Array de bytes que indican los das festivos.
        private byte[] _DiasFestivos;
        public byte[] DiasFestivos { get { return _DiasFestivos; } set { _DiasFestivos = value; OnPropertyChanged(); } }
        
        // Hojas de liquidacin en las que se utilizada el calendario.
        private ICollection<Liquidacion> _Liquidaciones;
        public ICollection<Liquidacion> Liquidaciones { get { return _Liquidaciones; } set { _Liquidaciones = value; OnPropertyChanged(); } }

        // Usuarios que utilizan por defecto el calendario.        
        //private ICollection<Usuario> _Usuarios;
        //public ICollection<Usuario> Usuarios { get { return _Usuarios; } set { _Usuarios = value; OnPropertyChanged(); } }
    }
}
