using System;
using System.Collections.Generic;

namespace LiquidacionGastos.Models
{
    public partial class CambioEstadoLiquidacion
    {
        public CambioEstadoLiquidacion()
        {
            this.Notificaciones = new List<Notificacion>();
        }

        // Identificador interno del cambio de estado de la hoja de liquidacin.
        public System.Guid IdCambioEstadoLiquidacion { get; set; }

        // Descripcin de la causa en caso de rechazo.
        public string MotivoRechazo { get; set; }

        // Estado de liquidacin anterior al cambio.
        public Nullable<int> IdEstadoAnteriorLiquidacion { get; set; }        
        private EstadoLiquidacion _EstadoAnteriorLiquidacion;
        public EstadoLiquidacion EstadoAnteriorLiquidacion
        {
            get { return _EstadoAnteriorLiquidacion; }
            set
            {
                _EstadoAnteriorLiquidacion = value;

                if (_EstadoAnteriorLiquidacion != null)
                    IdEstadoAnteriorLiquidacion = _EstadoAnteriorLiquidacion.IdEstadoLiquidacion;
            }
        }        

        // Estado de liquidacin posterior al cambio.
        public int IdEstadoNuevoLiquidacion { get; set; }
        private EstadoLiquidacion _EstadoNuevoLiquidacion;
        public EstadoLiquidacion EstadoNuevoLiquidacion
        {
            get { return _EstadoNuevoLiquidacion; }
            set
            {
                _EstadoNuevoLiquidacion = value;

                if (_EstadoNuevoLiquidacion != null)
                    IdEstadoNuevoLiquidacion = _EstadoNuevoLiquidacion.IdEstadoLiquidacion;
            }
        }
 

        // Marca de tiempo en la que se produce el cambio de estado.
        public System.DateTime FechaCambioEstadoLiquidacion { get; set; } 
        
        // Liquidacin a la que pertene el cambio de estado.
        public System.Guid IdLiquidacion { get; set; }
        private Liquidacion _Liquidacion;
        public Liquidacion Liquidacion
        {
            get { return _Liquidacion; }
            set
            {
                _Liquidacion = value;

                if (_Liquidacion != null)
                    IdLiquidacion = _Liquidacion.IdLiquidacion;
            }
        }        

        // Notificaciones asociadas al cambio de estado.
        public ICollection<Notificacion> Notificaciones { get; set; }
    }
}
