using LiquidacionGastos.Framework;
using System;
using System.Collections.Generic;

namespace LiquidacionGastos.Models
{
    public partial class Departamento : ObservableObject
    {
        public Departamento()
        {
            this.Subdepartamentos = new List<Departamento>();
            this.Usuarios = new List<Usuario>();
        }

        // Identificador interno del departamento.
        private System.Guid _IdDepartamento;
        public System.Guid IdDepartamento { get { return _IdDepartamento; } set { _IdDepartamento = value; OnPropertyChanged(); } }

        // Nombre completo del departamento.
        private string _Nombre;
        public string Nombre { get { return _Nombre; } set { _Nombre = value; OnPropertyChanged(); } }
        
        // Subdepartamentos que dependenden de este.
        public ICollection<Departamento> Subdepartamentos { get; set; }

        // Usuarios asociados al departamento.
        public ICollection<Usuario> Usuarios { get; set; }

        // Departamento del que depende este departamento.
        private Nullable<System.Guid> _IdSuperdepartamento;
        public Nullable<System.Guid> IdSuperdepartamento { get { return _IdSuperdepartamento; } set { _IdSuperdepartamento = value; OnPropertyChanged(); } }
        private Departamento _Superdepartamento;
        public Departamento Superdepartamento 
        {
            get { return _Superdepartamento; } 
            set 
            { 
                _Superdepartamento = value;
                
                if (_Superdepartamento != null)
                    _IdSuperdepartamento = _Superdepartamento.IdDepartamento;

                OnPropertyChanged(); 
            } 
        }
        
        // Responsable de este departamento.
        private Nullable<System.Guid> _IdResponsable;
        public Nullable<System.Guid> IdResponsable { get { return _IdResponsable; } set { _IdResponsable = value; OnPropertyChanged(); } }
        private Usuario _Responsable;
        public Usuario Responsable 
        {
            get { return _Responsable; }
            set
            {
                _Responsable = value;

                if (_Responsable != null)
                    _IdResponsable = _Responsable.IdUsuario;

                OnPropertyChanged();
            }     
        }        
    }
}
