using System;
using System.Collections.Generic;

namespace LiquidacionGastos.Models
{
    public partial class EstadoLiquidacion
    {
        public EstadoLiquidacion()
        {
            this.CambiosEstadoAnteriorLiquidacion = new List<CambioEstadoLiquidacion>();
            this.CambiosEstadoNuevoLiquidacion = new List<CambioEstadoLiquidacion>();
            this.Liquidaciones = new List<Liquidacion>();
        }

        // Identificador interno del estado de la liquidacin.
        public int IdEstadoLiquidacion { get; set; }

        // Nombre del estado de liquidacin.
        public string Nombre { get; set; }

        // Cambios de estado "anteriores" que se produjeron en la liquidacin.
        public ICollection<CambioEstadoLiquidacion> CambiosEstadoAnteriorLiquidacion { get; set; }

        // Cambios de estado "nuevos" que se produjeron en la liquidacin.
        public ICollection<CambioEstadoLiquidacion> CambiosEstadoNuevoLiquidacion { get; set; }

        // Liquidaciones con estado.
        public ICollection<Liquidacion> Liquidaciones { get; set; }
    }
}
