using LiquidacionGastos.Framework;
using System;
using System.Collections.Generic;

namespace LiquidacionGastos.Models
{
    public partial class Gasto : ObservableObject
    {
        // Identificador interno del gasto.
        public System.Guid IdGasto { get; set; }

        // Fecha en la que se produjo el gasto.        
        private System.DateTime _Fecha;
        public System.DateTime Fecha { get { return _Fecha; } set { _Fecha = value; OnPropertyChanged(); } }
        

        // Importe del gasto.    
        private decimal _Importe;
        public decimal Importe { get { return _Importe; } set { _Importe = value; OnPropertyChanged(); } }
        

        // Descripcin libre del gasto.
        public string Descripcion { get; set; }

        // Tipo de gasto.
        public int IdTipo { get; set; }
        private TipoGasto _Tipo;
        public TipoGasto Tipo
        {
            get { return _Tipo; }
            set 
	        { 
		        _Tipo = value;

                if (_Tipo != null)
                    IdTipo = _Tipo.IdTipoGasto;

                OnPropertyChanged();
	        }
        }
        
        // Liquidacin a la que est asociado el gasto.
        public System.Guid IdLiquidacion { get; set; }
        private Liquidacion _Liquidacion;
        public Liquidacion Liquidacion
        {
            get { return _Liquidacion; }
            set
            {
                _Liquidacion = value;

                if (_Liquidacion != null)
                    IdLiquidacion = _Liquidacion.IdLiquidacion;

                OnPropertyChanged();
            }
        }

        public System.Guid IdCambioMoneda { get; set; }
        private CambioMoneda _CambioMoneda;
        public CambioMoneda CambioMoneda
        {
            get { return _CambioMoneda; }
            set
            {
                _CambioMoneda = value;

                if (_CambioMoneda != null)
                    IdCambioMoneda = _CambioMoneda.IdCambioMoneda;

                OnPropertyChanged();
            }
        }        

        public byte[] ImagenComprobante { get; set; }
        
    }
}
