using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using LiquidacionGastos.Models.Mapping;

namespace LiquidacionGastos.Models
{
    public partial class LGContext : DbContext
    {
        static LGContext()
        {
            // Si la base de datos NO existe no realiza ninguna accin.
            //Database.SetInitializer<LGContext>(null);

            // Si la base de datos NO existe crea una nueva.
            Database.SetInitializer<LGContext>(new System.Data.Entity.CreateDatabaseIfNotExists<LGContext>());
        }

        public LGContext() : base("Name=LGContext")
        {
            this.Configuration.LazyLoadingEnabled = false;
        }

        public DbSet<Calendario> Calendarios { get; set; }
        public DbSet<CambioEstadoLiquidacion> CambiosEstadoLiquidacion { get; set; }
        public DbSet<CambioMoneda> CambiosMoneda { get; set; }
        public DbSet<Departamento> Departamentos { get; set; }
        public DbSet<EstadoLiquidacion> EstadosLiquidacion { get; set; }
        public DbSet<Gasto> Gastos { get; set; }
        public DbSet<Liquidacion> Liquidaciones { get; set; }
        public DbSet<Moneda> Monedas { get; set; }
        public DbSet<Notificacion> Notificaciones { get; set; }
        public DbSet<ParametroSistema> ParametrosSistema { get; set; }
        public DbSet<TipoGasto> TiposGasto { get; set; }
        public DbSet<TrackingEntry> Tracking { get; set; }
        public DbSet<Usuario> Usuarios { get; set; }

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            modelBuilder.Configurations.Add(new CalendarioMap());
            modelBuilder.Configurations.Add(new CambioEstadoLiquidacionMap());
            modelBuilder.Configurations.Add(new CambioMonedaMap());
            modelBuilder.Configurations.Add(new DepartamentoMap());
            modelBuilder.Configurations.Add(new EstadoLiquidacionMap());
            modelBuilder.Configurations.Add(new GastoMap());
            modelBuilder.Configurations.Add(new LiquidacionMap());
            modelBuilder.Configurations.Add(new MonedaMap());
            modelBuilder.Configurations.Add(new NotificacionMap());
            modelBuilder.Configurations.Add(new ParametroSistemaMap());
            modelBuilder.Configurations.Add(new TipoGastoMap());
            modelBuilder.Configurations.Add(new TrackingEntryMap());
            modelBuilder.Configurations.Add(new UsuarioMap());
        }
    }
}
