using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity.ModelConfiguration;

namespace LiquidacionGastos.Models.Mapping
{
    public class CalendarioMap : EntityTypeConfiguration<Calendario>
    {
        public CalendarioMap()
        {
            // Primary Key
            this.HasKey(t => t.IdCalendario);

            // Properties
            this.Property(t => t.Nombre)
                .IsRequired()
                .HasMaxLength(150);
            this.Property(t => t.DiasFestivos)
                .IsOptional()
                .IsFixedLength()
                .HasMaxLength(50);

            // Table & Column Mappings
            this.ToTable("Calendarios");
            this.Property(t => t.IdCalendario).HasColumnName("IdCalendario");
            this.Property(t => t.Nombre).HasColumnName("NombreCalendario");
            this.Property(t => t.DiasFestivos).HasColumnName("DiasFestivosCalendario");

            // Relationships
        }
    }
}
