using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity.ModelConfiguration;

namespace LiquidacionGastos.Models.Mapping
{
    public class CambioEstadoLiquidacionMap : EntityTypeConfiguration<CambioEstadoLiquidacion>
    {
        public CambioEstadoLiquidacionMap()
        {
            // Primary Key
            this.HasKey(t => t.IdCambioEstadoLiquidacion);

            // Properties
            this.Property(t => t.FechaCambioEstadoLiquidacion)
                .IsRequired();

            // Table & Column Mappings
            this.ToTable("CambiosEstadoLiquidacion");
            this.Property(t => t.IdCambioEstadoLiquidacion).HasColumnName("IdCambioEstadoLiquidacion");
            this.Property(t => t.IdLiquidacion).HasColumnName("IdLiquidacion");
            this.Property(t => t.MotivoRechazo).HasColumnName("MotivoRechazoLiquidacion");
            this.Property(t => t.IdEstadoAnteriorLiquidacion).HasColumnName("IdEstadoAnteriorLiquidacion");
            this.Property(t => t.IdEstadoNuevoLiquidacion).HasColumnName("IdEstadoNuevoLiquidacion");
            this.Property(t => t.FechaCambioEstadoLiquidacion).HasColumnName("FechaCambioEstadoLiquidacion");

            // Relationships
            this.HasOptional(t => t.EstadoAnteriorLiquidacion)
                .WithMany(t => t.CambiosEstadoAnteriorLiquidacion)
                .HasForeignKey(d => d.IdEstadoAnteriorLiquidacion)
                .WillCascadeOnDelete(false);
            this.HasRequired(t => t.EstadoNuevoLiquidacion)
                .WithMany(t => t.CambiosEstadoNuevoLiquidacion)
                .HasForeignKey(d => d.IdEstadoNuevoLiquidacion)
                .WillCascadeOnDelete(false);
            this.HasRequired(t => t.Liquidacion)
                .WithMany(t => t.CambiosEstado)
                .HasForeignKey(d => d.IdLiquidacion);
        }
    }
}
