﻿using System;
using System.Collections.Generic;
using System.Data.Entity.ModelConfiguration;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.Models.Mapping
{
    public class CambioMonedaMap : EntityTypeConfiguration<CambioMoneda>
    {
        public CambioMonedaMap()
        {
            // Primary Key
            this.HasKey(t => t.IdCambioMoneda);

            // Properties
            this.Property(t => t.ValorCambio)
                .HasPrecision(18, 9);

            // Table & Column Mappings
            this.ToTable("CambiosMoneda");
            this.Property(t => t.IdCambioMoneda).HasColumnName("IdCambioMoneda");
            this.Property(t => t.FechaCambio).HasColumnName("FechaCambioMoneda");
            this.Property(t => t.ValorCambio).HasColumnName("ValorCambioMoneda");
            this.Property(t => t.IdMoneda).HasColumnName("IdMoneda");

            // Relationships
            this.HasRequired(t => t.Moneda)
                .WithMany(t => t.CambiosMoneda)
                .HasForeignKey(d => d.IdMoneda);
        }
    }
}
