using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity.ModelConfiguration;

namespace LiquidacionGastos.Models.Mapping
{
    public class DepartamentoMap : EntityTypeConfiguration<Departamento>
    {
        public DepartamentoMap()
        {
            // Primary Key
            this.HasKey(t => t.IdDepartamento);

            // Properties
            this.Property(t => t.Nombre)
                .IsRequired()
                .HasMaxLength(150);

            // Table & Column Mappings
            this.ToTable("Departamentos");
            this.Property(t => t.IdDepartamento).HasColumnName("IdDepartamento");
            this.Property(t => t.Nombre).HasColumnName("NombreDepartamento");
            this.Property(t => t.IdResponsable).HasColumnName("IdResponsableDepartamento");
            this.Property(t => t.IdSuperdepartamento).HasColumnName("IdSuperdepartamento");

            // Relationships
            this.HasOptional(t => t.Superdepartamento)
                .WithMany(t => t.Subdepartamentos)
                .HasForeignKey(d => d.IdSuperdepartamento);
            this.HasOptional(t => t.Responsable)
                .WithMany(t => t.DepartamentosSupervisados)
                .HasForeignKey(d => d.IdResponsable);

        }
    }
}
