using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity.ModelConfiguration;

namespace LiquidacionGastos.Models.Mapping
{
    public class LiquidacionMap : EntityTypeConfiguration<Liquidacion>
    {
        public LiquidacionMap()
        {
            // Primary Key
            this.HasKey(t => t.IdLiquidacion);

            // Properties
            // Table & Column Mappings
            this.ToTable("Liquidaciones");
            this.Property(t => t.IdLiquidacion).HasColumnName("IdLiquidacion");
            this.Property(t => t.Fecha).HasColumnName("FechaLiquidacion");
            this.Property(t => t.IdEstado).HasColumnName("IdEstadoLiquidacion");
            this.Property(t => t.IdUsuario).HasColumnName("IdUsuarioLiquidacion");
            this.Property(t => t.Importe).HasColumnName("ImporteLiquidacion");

            // Relationships
            this.HasRequired(t => t.Estado)
                .WithMany(t => t.Liquidaciones)
                .HasForeignKey(d => d.IdEstado);
            this.HasRequired(t => t.Usuario)
                .WithMany(t => t.Liquidaciones)
                .HasForeignKey(d => d.IdUsuario);
            this.HasOptional(t => t.Calendario)
                .WithMany(t => t.Liquidaciones)
                .HasForeignKey(d => d.IdCalendario);
        }
    }
}
