﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity.ModelConfiguration;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.Models.Mapping
{
    public class MonedaMap : EntityTypeConfiguration<Moneda>
    {
        public MonedaMap()
        {
            // Primary Key
            this.HasKey(t => t.IdMoneda);

            // Properties
            this.Property(t => t.IdMoneda)
                .HasDatabaseGeneratedOption(DatabaseGeneratedOption.None);

            this.Property(t => t.Nombre)
                .IsRequired()
                .HasMaxLength(150);

            this.Property(t => t.Codigo)
                .IsRequired()
                .HasMaxLength(3);


            // Table & Column Mappings
            this.ToTable("Monedas");
            this.Property(t => t.IdMoneda).HasColumnName("IdMoneda");
            this.Property(t => t.Nombre).HasColumnName("NombreMoneda");
            this.Property(t => t.Codigo).HasColumnName("CodigoMoneda");
        }
    }
}
