using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity.ModelConfiguration;

namespace LiquidacionGastos.Models.Mapping
{
    public class NotificacionMap : EntityTypeConfiguration<Notificacion>
    {
        public NotificacionMap()
        {
            // Primary Key
            this.HasKey(t => t.IdNotificacion);

            // Properties
            this.Property(t => t.EstaNotificado)
                .IsRequired();
            this.Property(t => t.FechaNotificacion)
                .IsRequired();

            // Table & Column Mappings
            this.ToTable("Notificaciones");
            this.Property(t => t.IdNotificacion).HasColumnName("IdNotificacion");
            this.Property(t => t.FechaNotificacion).HasColumnName("FechaNotificacion");
            this.Property(t => t.EstaNotificado).HasColumnName("EstaNotificado");
            this.Property(t => t.IdCambioEstadoLiquidacion).HasColumnName("IdCambioEstadoLiquidacion");

            // Relationships
            this.HasRequired(t => t.CambioEstadoLiquidacion)
                .WithMany(t => t.Notificaciones)
                .HasForeignKey(d => d.IdCambioEstadoLiquidacion);

        }
    }
}
