using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity.ModelConfiguration;

namespace LiquidacionGastos.Models.Mapping
{
    public class ParametroSistemaMap : EntityTypeConfiguration<ParametroSistema>
    {
        public ParametroSistemaMap()
        {
            // Primary Key
            this.HasKey(t => t.IdParametroSistema);

            // Properties
            this.Property(t => t.IdParametroSistema)
                .HasDatabaseGeneratedOption(DatabaseGeneratedOption.None);

            this.Property(t => t.Nombre)
                .IsRequired()
                .HasMaxLength(50);

            this.Property(t => t.Valor)
                .IsRequired()
                .HasMaxLength(1024);

            // Table & Column Mappings
            this.ToTable("ParametrosSistema");
            this.Property(t => t.IdParametroSistema).HasColumnName("IdParametroSistema");
            this.Property(t => t.Nombre).HasColumnName("NombreParametroSistema");
            this.Property(t => t.Valor).HasColumnName("ValorParametroSistema");
            this.Property(t => t.IdUsuario).HasColumnName("IdUsuarioParametro");

            // Relationships
            this.HasOptional(t => t.Usuario)
                .WithMany(t => t.Parametros)
                .HasForeignKey(d => d.IdUsuario);

        }
    }
}
