using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity.ModelConfiguration;

namespace LiquidacionGastos.Models.Mapping
{
    public class TrackingEntryMap : EntityTypeConfiguration<TrackingEntry>
    {
        public TrackingEntryMap()
        {
            // Primary Key
            this.HasKey(t => t.IdTracking);

            // Properties
            this.Property(t => t.IdTracking).IsRequired();
            this.Property(t => t.Fecha).IsRequired();
            this.Property(t => t.Guid).IsOptional();
            this.Property(t => t.Id).IsOptional();
            this.Property(t => t.Entidad).IsRequired();
            this.Property(t => t.Operacion).IsRequired();

            // Table & Column Mappings
            this.ToTable("Tracking");
            this.Property(t => t.Fecha).HasColumnName("FechaTrackingEntry");
            this.Property(t => t.Guid).HasColumnName("GuidEntidad");
            this.Property(t => t.Id).HasColumnName("IdEntidad");
            this.Property(t => t.Entidad).HasColumnName("Entidad");
            this.Property(t => t.Operacion).HasColumnName("Operacion");

            // Relationships
        }
    }
}