using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity.ModelConfiguration;

namespace LiquidacionGastos.Models.Mapping
{
    public class UsuarioMap : EntityTypeConfiguration<Usuario>
    {
        public UsuarioMap()
        {
            // Primary Key
            this.HasKey(t => t.IdUsuario);

            // Properties
            this.Property(t => t.Nombre)
                .IsRequired();

            // Table & Column Mappings
            this.ToTable("Usuarios");
            this.Property(t => t.IdUsuario).HasColumnName("IdUsuario");
            this.Property(t => t.Nombre).HasColumnName("NombreUsuario");
            this.Property(t => t.EsAdministrador).HasColumnName("EsAdministrador");
            this.Property(t => t.IdDepartamento).HasColumnName("IdDepartamentoUsuario");
            this.Property(t => t.Identificador).HasColumnName("Identificador");
            this.Property(t => t.HashContrasena).HasColumnName("HashContrasena");
            this.Property(t => t.EstaActivadoLogin).HasColumnName("EstaActivadoLogin");
            this.Property(t => t.Email).HasColumnName("EmailUsuario");
            this.Property(t => t.EstaActivadoNotificarPorEmail).HasColumnName("EstaActivadoNotificarPorEmail");
            //this.Property(t => t.IdCalendario).HasColumnName("IdCalendario");

            // Relationships
            this.HasOptional(t => t.Departamento)
                .WithMany(t => t.Usuarios)
                .HasForeignKey(d => d.IdDepartamento);

            //this.HasOptional(t => t.Calendario)
            //    .WithMany(t => t.Usuarios)
            //    .HasForeignKey(c => c.IdCalendario);
        }
    }
}
