using LiquidacionGastos.Framework;
using System;
using System.Collections.Generic;

namespace LiquidacionGastos.Models
{
    public partial class ParametroSistema : ObservableObject
    {
        public int IdParametroSistema { get; set; }
        public string Nombre { get; set; }
        public string Valor { get; set; }

        // Usuario al que pertenece el parametro.
        private Nullable<System.Guid> _IdUsuario;
        public Nullable<System.Guid> IdUsuario { get { return _IdUsuario; } set { _IdUsuario = value; OnPropertyChanged(); } }
        private Usuario _Usuario;
        public Usuario Usuario
        {
            get { return _Usuario; }
            set
            {
                _Usuario = value;

                if (_Usuario != null)
                    _IdUsuario = _Usuario.IdUsuario;

                OnPropertyChanged();
            }
        }
    }
}
