﻿using LiquidacionGastos.Models;
using LiquidacionGastos.UnitsOfWork;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.Repositories
{
    public class MasterTypeFactory
    {                
        public static EstadoLiquidacion GetEstadoLiquidacion(EstadoLiquidacionType tipo)
        {
            using (MasterTypeUnitOfWork uow = new MasterTypeUnitOfWork())
            {
                return uow.GetEstadoLiquidacion(tipo);
            }
        }

        public static TipoGasto GetTipoGasto(TipoGastoType tipo)
        {
            using (MasterTypeUnitOfWork uow = new MasterTypeUnitOfWork())
            {
                return uow.GetTipoGasto(tipo);
            }
        }

        public static ICollection<TipoGasto> ListTiposGasto()
        {
            using (MasterTypeUnitOfWork uow = new MasterTypeUnitOfWork())
            {
                return uow.ListTiposGasto();
            }
        }

        public static CambioMoneda GetCambioMoneda(string codigoMoneda, DateTime fechaCambio)
        {
            using (MasterTypeUnitOfWork uow = new MasterTypeUnitOfWork())
            {
                return uow.GetCambioMoneda(codigoMoneda, fechaCambio);
            }
        }

        public static CambioMoneda GetCambioMoneda(string codigoMoneda)
        {
            using (MasterTypeUnitOfWork uow = new MasterTypeUnitOfWork())
            {
                return uow.GetCambioMoneda(codigoMoneda, DateTime.Today);
            }
        }

        public static ICollection<CambioMoneda> ListCambiosMonedaMostRecent()
        {
            using (MasterTypeUnitOfWork uow = new MasterTypeUnitOfWork())
            {
                return uow.ListCambiosMonedaMostRecent();
            }
        }
    }
}
