﻿using LiquidacionGastos.Models;
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.Repositories
{
    public class CambioEstadoLiquidacionRepository : EntityFrameworkTrackedRepository<CambioEstadoLiquidacion>
    {
        public CambioEstadoLiquidacionRepository(LGContext context)
            : base(context)
        {
        }

        protected override Nullable<Guid> GetGuid(CambioEstadoLiquidacion entity)
        {
            return entity.IdCambioEstadoLiquidacion;
        }

        public CambioEstadoLiquidacion CreateCambioEstadoLiquidacion(Liquidacion liquidacion, EstadoLiquidacion estadoAnterior, EstadoLiquidacion estadoNuevo)
        {
            CambioEstadoLiquidacion cambioEstadoLiquidacion = new CambioEstadoLiquidacion()
            {
                IdCambioEstadoLiquidacion = Guid.NewGuid(),
                Liquidacion = liquidacion,
                EstadoAnteriorLiquidacion = estadoAnterior,
                EstadoNuevoLiquidacion = estadoNuevo,
                FechaCambioEstadoLiquidacion = DateTime.Now
            };

            return cambioEstadoLiquidacion;
        }

        public CambioEstadoLiquidacion GetCambioEstadoLiquidacion(Guid idCambioEstadoLiquidacion)
        {
            CambioEstadoLiquidacion cambioEstadoLiquidacion = this.Get(d => d.IdCambioEstadoLiquidacion == idCambioEstadoLiquidacion);

            //if (cambioEstadoLiquidacion == null)
            //    throw new DataNotFoundException("idCambioEstadoLiquidacion", idCambioEstadoLiquidacion, "No existe ningún cambioEstadoLiquidacion con el valor de idCambioEstadoLiquidacion especificado.");

            return cambioEstadoLiquidacion;
        }

        public IQueryable<CambioEstadoLiquidacion> ListCambioEstadosLiquidacion()
        {
            return this.ListCambioEstadosLiquidacion(null);
        }

        public IQueryable<CambioEstadoLiquidacion> ListCambioEstadosLiquidacion(Expression<Func<CambioEstadoLiquidacion, bool>> filterPredicate)
        {
            if (filterPredicate == null)
                filterPredicate = x => true;

            return this.List(filterPredicate);
        }

        public void InsertCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion)
        {
            this.Insert(cambioEstadoLiquidacion);
        }

        public void UpdateCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion)
        {
            this.Update(cambioEstadoLiquidacion);
        }

        public void DeleteCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion)
        {
            this.Delete(cambioEstadoLiquidacion);
        }

        public void RefreshCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion)
        {
            this.Refresh(cambioEstadoLiquidacion);
        }
    }

}
