﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LiquidacionGastos.Repositories
{
    public class DataNotFoundException : RepositoryException
    {
        public string DataName { get; private set; }
        public object DataValue { get; private set; }
        public DataNotFoundException(string dataName, object dataValue)
        {
            this.DataName = dataName;
            this.DataValue = dataValue;
        }

        public DataNotFoundException(string dataName, object dataValue, string message) : base(message)
        {
            this.DataName = dataName;
            this.DataValue = dataValue;
        }

        public DataNotFoundException(string dataName, object dataValue, string message, Exception inner) : base(message, inner)
        {
            this.DataName = dataName;
            this.DataValue = dataValue;
        }
    }
}
