﻿using LiquidacionGastos.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.Repositories
{
    public class EstadoLiquidacionRepository : EntityFrameworkTrackedRepository<EstadoLiquidacion>
    {

        public EstadoLiquidacionRepository(LGContext context)
            : base(context) 
        {
        }

        protected override Nullable<int> GetId(EstadoLiquidacion entity)
        {
            return entity.IdEstadoLiquidacion;
        }

        public EstadoLiquidacion CreateEstadoLiquidacion()
        {
            EstadoLiquidacion EstadoLiquidacion = new EstadoLiquidacion()
            {
                IdEstadoLiquidacion = -1
            };

            return EstadoLiquidacion;
        }

        public EstadoLiquidacion GetEstadoLiquidacion(int idEstadoLiquidacion)
        {
            EstadoLiquidacion estadoLiquidacion = this.Get(el => el.IdEstadoLiquidacion == idEstadoLiquidacion);

            //if (estadoLiquidacion == null)
            //    throw new DataNotFoundException("idEstadoLiquidacion", idEstadoLiquidacion, "No existe ningún estado de liquidación con el valor de idEstadoLiquidacion especificado.");

            return estadoLiquidacion;
        }

        public IQueryable<EstadoLiquidacion> ListEstadosLiquidacion()
        {
            return this.ListLiquidaciones(null);
        }

        public IQueryable<EstadoLiquidacion> ListLiquidaciones(Expression<Func<EstadoLiquidacion, bool>> filterPredicate)
        {
            if (filterPredicate == null)
                filterPredicate = x => true;

            return this.List(filterPredicate);//.Include();
        }

        public void LoadLiquidaciones(EstadoLiquidacion estadoLiquidacion)
        {
            this.Load(estadoLiquidacion, el => el.Liquidaciones);
        }

        public void InsertEstadoLiquidacion(EstadoLiquidacion estadoLiquidacion)
        {
            this.Insert(estadoLiquidacion);
        }

        public void UpdateEstadoLiquidacion(EstadoLiquidacion estadoLiquidacion)
        {
            this.Update(estadoLiquidacion);
        }

        public void DeleteEstadoLiquidacion(EstadoLiquidacion estadoLiquidacion)
        {
            this.Delete(estadoLiquidacion);
        }

        public void RefreshLiquidacion(EstadoLiquidacion estadoLiquidacion)
        {
            this.Refresh(estadoLiquidacion);
        }
    }
}
