﻿using LiquidacionGastos.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

// Códigos de moneda ISO 4217
namespace LiquidacionGastos.Repositories
{
    public class MonedaRepository : EntityFrameworkTrackedRepository<Moneda>
    {
        //public MonedaRepository()
        //    : base()
        //{
        //}

        public MonedaRepository(LGContext context)
            : base(context) 
        {
        }

        protected override Nullable<int> GetId(Moneda entity)
        {
            return entity.IdMoneda;
        }

        public Moneda CreateMoneda()
        {
            Moneda moneda = new Moneda()
            {
                IdMoneda = -1
            };

            return moneda;
        }

        public Moneda GetMoneda(int idMoneda)
        {
            Moneda moneda = this.Get(t => t.IdMoneda == idMoneda);

            //if (moneda == null)
            //    throw new DataNotFoundException("idMoneda", idMoneda, "No existe ninguna moneda con el valor de idMoneda especificado.");

            return moneda;
        }

        public Moneda GetModenaByNombre(string nombre)
        {
            Moneda moneda = this.Get(t => t.Nombre == nombre);

            //if (moneda == null)
            //    throw new DataNotFoundException("moneda", moneda, "No existe ninguna moneda con el nombre especificado.");

            return moneda;
        }

        public Moneda GetModenaByCodigo(string codigo)
        {
            Moneda moneda = this.Get(t => t.Codigo == codigo);

            //if (moneda == null)
            //    throw new DataNotFoundException("moneda", moneda, "No existe ninguna moneda con el código especificado.");

            return moneda;
        }

        public IQueryable<Moneda> ListMonedas()
        {
            return this.ListMonedas(null);
        }

        public IQueryable<Moneda> ListMonedas(Expression<Func<Moneda, bool>> filterPredicate)
        {
            if (filterPredicate == null)
                filterPredicate = x => true;

            return this.List(filterPredicate);
        }

        public void LoadCambiosMoneda(Moneda moneda)
        {
            this.Load(moneda, t => t.CambiosMoneda);
        }

        public void InsertMoneda(Moneda moneda)
        {
            this.Insert(moneda);
        }

        public void UpdateMoneda(Moneda moneda)
        {
            this.Update(moneda);
        }

        public void DeleteMoneda(Moneda moneda)
        {
            this.Delete(moneda);
        }

        public void RefreshMoneda(Moneda moneda)
        {
            this.Refresh(moneda);
        }
    }
}
