﻿using LiquidacionGastos.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Data.Entity;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.Repositories
{
    public class TipoGastoRepository : EntityFrameworkTrackedRepository<TipoGasto>
    {

        public TipoGastoRepository(LGContext context)
            : base(context)
        {
        }

        protected override Nullable<int> GetId(TipoGasto entity)
        {
            return entity.IdTipoGasto;
        }

        public TipoGasto CreateTipoGasto()
        {
            TipoGasto TipoGasto = new TipoGasto()
            {
                IdTipoGasto = -1
            };

            return TipoGasto;
        }

        public TipoGasto GetTipoGasto(int idTipoGasto)
        {
            TipoGasto estadoLiquidacion = this.Get(t => t.IdTipoGasto == idTipoGasto);

            //if (estadoLiquidacion == null)
            //    throw new DataNotFoundException("idTipoGasto", idTipoGasto, "No existe ningún tipo de gasto con el valor de idTipoGasto especificado.");

            return estadoLiquidacion;
        }

        public IQueryable<TipoGasto> ListTiposGasto()
        {
            return this.ListTiposGasto(null);
        }

        public IQueryable<TipoGasto> ListTiposGasto(Expression<Func<TipoGasto, bool>> filterPredicate)
        {
            if (filterPredicate == null)
                filterPredicate = x => true;

            return this.List(filterPredicate);
        }

        public void LoadGastos(TipoGasto tipoGasto)
        {
            this.Load(tipoGasto, t => t.Gastos);
        }

        public void InsertTipoGasto(TipoGasto tipoGasto)
        {
            this.Insert(tipoGasto);
        }

        public void UpdateTipoGasto(TipoGasto tipoGasto)
        {
            this.Update(tipoGasto);
        }

        public void DeleteTipoGasto(TipoGasto tipoGasto)
        {
            this.Delete(tipoGasto);
        }

        public void RefreshTipoGasto(TipoGasto tipoGasto)
        {
            this.Refresh(tipoGasto);
        }
    }
}
