﻿using LiquidacionGastos.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.Repositories
{
    public class TrackingEntryRepository : EntityFrameworkRepository<TrackingEntry>
    {
        public TrackingEntryRepository(LGContext context)
            : base(context)
        {
        }

        public TrackingEntry CreateTrackingEntry()
        {
            TrackingEntry trackingEntry = new TrackingEntry();
            return trackingEntry;
        }

        public TrackingEntry GetTrackingEntry(Guid idTrackingEntry)
        {
            TrackingEntry trackingEntry = this.Get(t => t.IdTracking == idTrackingEntry);

            //if (trackingEntry == null)
            //    throw new DataNotFoundException("idTrackingEntry", idTrackingEntry, "No existe ninguna entrada de seguimiento con el valor de idTrackingEntry especificado.");

            return trackingEntry;
        }

        public TrackingEntry GetTrackingEntryBy(DateTime fecha, TrackingEntry.EntidadType entidadType)
        {
            int entidad = (int)entidadType;
            TrackingEntry trackingEntry = this.Get(t => t.Fecha == fecha &&
                                                        t.Entidad == entidad);

            //if (trackingEntry == null)
            //    throw new DataNotFoundException("trackingEntry", trackingEntry, "No existe ningún trackingEntry con el nombre especificado.");

            return trackingEntry;
        }

        public IQueryable<TrackingEntry> ListTrackingEntries()
        {
            return this.ListTrackingEntries(null);
        }

        public IQueryable<TrackingEntry> ListTrackingEntries(Expression<Func<TrackingEntry, bool>> filterPredicate)
        {
            if (filterPredicate == null)
                filterPredicate = x => true;

            return this.List(filterPredicate);
        }

        public void InsertTrackingEntry(TrackingEntry trackingEntry)
        {
            this.Insert(trackingEntry);
        }

        public void UpdateTrackingEntry(TrackingEntry trackingEntry)
        {
            this.Update(trackingEntry);
        }

        public void DeleteTrackingEntry(TrackingEntry trackingEntry)
        {
            this.Delete(trackingEntry);
        }

        public void RefreshTrackingEntry(TrackingEntry trackingEntry)
        {
            this.Refresh(trackingEntry);
        }
    }

}
