﻿using LiquidacionGastos.Models;
using LiquidacionGastos.UnitsOfWork;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.UnitsOfWork
{
    public class EntityFrameworkTrackedUnitOfWork : EntityFrameworkUnitOfWork
    {
        private bool _IsTrackingEnabled;
        public bool IsTrackingEnabled { get { return _IsTrackingEnabled; } set { _IsTrackingEnabled = value; OnTrackedChanged(); } }
        
        public EntityFrameworkTrackedUnitOfWork()
        {
            this.IsTrackingEnabled = true;
        }

        public EntityFrameworkTrackedUnitOfWork(LGContext context) : base(context)
        {
            this.IsTrackingEnabled = true;
        }

        public virtual void OnTrackedChanged()
        {
        }
    }
}
