﻿using LiquidacionGastos.Models;
using LiquidacionGastos.Repositories;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.UnitsOfWork
{
    public class CalendarioUnitOfWork : EntityFrameworkTrackedUnitOfWork
    {
        private CalendarioRepository CalendarioRepository { get; set; }        

        public CalendarioUnitOfWork()
        {
        }
        public CalendarioUnitOfWork(LGContext context) : base(context) 
        {            
        }

        protected override void OnInitializeRepositories()
        {
            this.CalendarioRepository = new CalendarioRepository(this.Context);
        }

        public override void OnTrackedChanged()
        {
            this.CalendarioRepository.IsTrackingEnabled = this.IsTrackingEnabled;
        }

        public Calendario GetCalendario(Guid idCalendario)
        {
            if (idCalendario == null)
                throw new ArgumentNullException("idCalendario");

            return this.CalendarioRepository.GetCalendario(idCalendario);
        }

        public void InsertCalendario(Calendario calendario)
        {
            if (calendario == null)
                throw new ArgumentNullException("calendario");

            this.CalendarioRepository.InsertCalendario(calendario);
        }

        public void UpdateCalendario(Calendario calendario)
        {
            if (calendario == null)
                throw new ArgumentNullException("calendario");

            this.CalendarioRepository.UpdateCalendario(calendario);
        }

        public void DeleteCalendario(Calendario calendario)
        {
            if (calendario == null)
                throw new ArgumentNullException("calendario");

            this.CalendarioRepository.DeleteCalendario(calendario);
        }
    }
}
