﻿using LiquidacionGastos.Models;
using LiquidacionGastos.Repositories;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.UnitsOfWork
{
    public class CambioEstadoLiquidacionUnitOfWork : EntityFrameworkTrackedUnitOfWork
    {
        private CambioEstadoLiquidacionRepository CambioEstadoLiquidacionRepository { get; set; }

        public CambioEstadoLiquidacionUnitOfWork()
        {
        }

        public CambioEstadoLiquidacionUnitOfWork(LGContext context) : base(context) 
        {            
        }

        protected override void OnInitializeRepositories()
        {
            this.CambioEstadoLiquidacionRepository = new CambioEstadoLiquidacionRepository(this.Context);
        }

        public override void OnTrackedChanged()
        {
            this.CambioEstadoLiquidacionRepository.IsTrackingEnabled = this.IsTrackingEnabled;
        }

        public CambioEstadoLiquidacion GetCambioEstadoLiquidacion(Guid idCambioEstadoLiquidacion)
        {
            if (idCambioEstadoLiquidacion == null)
                throw new ArgumentNullException("idCambioEstadoLiquidacion");

            return this.CambioEstadoLiquidacionRepository.GetCambioEstadoLiquidacion(idCambioEstadoLiquidacion);
        }

        public void InsertCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion)
        {
            if (cambioEstadoLiquidacion == null)
                throw new ArgumentNullException("cambioEstadoLiquidacion");

            this.CambioEstadoLiquidacionRepository.InsertCambioEstadoLiquidacion(cambioEstadoLiquidacion);
        }

        public void UpdateCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion)
        {
            if (cambioEstadoLiquidacion == null)
                throw new ArgumentNullException("cambioEstadoLiquidacion");

            this.CambioEstadoLiquidacionRepository.UpdateCambioEstadoLiquidacion(cambioEstadoLiquidacion);
        }

        public void DeleteCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion)
        {
            if (cambioEstadoLiquidacion == null)
                throw new ArgumentNullException("cambioEstadoLiquidacion");

            this.CambioEstadoLiquidacionRepository.DeleteCambioEstadoLiquidacion(cambioEstadoLiquidacion);
        }
    }
}
