﻿using LiquidacionGastos.Models;
using LiquidacionGastos.Repositories;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.UnitsOfWork
{
    public class CambioMonedaUnitOfWork : EntityFrameworkTrackedUnitOfWork
    {
        private CambioMonedaRepository CambioMonedaRepository { get; set; }

        public CambioMonedaUnitOfWork()
        {
        }

        public CambioMonedaUnitOfWork(LGContext context) : base(context) 
        {            
        }

        protected override void OnInitializeRepositories()
        {
            this.CambioMonedaRepository = new CambioMonedaRepository(this.Context);
        }

        public override void OnTrackedChanged()
        {
            this.CambioMonedaRepository.IsTrackingEnabled = this.IsTrackingEnabled;
        }

        public CambioMoneda GetCambioMoneda(Guid idCambioMoneda)
        {
            if (idCambioMoneda == null)
                throw new ArgumentNullException("idCambioMoneda");

            return this.CambioMonedaRepository.GetCambioMoneda(idCambioMoneda);
        }

        public void InsertCambioMoneda(CambioMoneda cambioMoneda)
        {
            if (cambioMoneda == null)
                throw new ArgumentNullException("cambioMoneda");

            this.CambioMonedaRepository.InsertCambioMoneda(cambioMoneda);
        }

        public void UpdateCambioMoneda(CambioMoneda cambioMoneda)
        {
            if (cambioMoneda == null)
                throw new ArgumentNullException("cambioMoneda");

            this.CambioMonedaRepository.UpdateCambioMoneda(cambioMoneda);
        }

        public void DeleteCambioMoneda(CambioMoneda cambioMoneda)
        {
            if (cambioMoneda == null)
                throw new ArgumentNullException("cambioMoneda");

            this.CambioMonedaRepository.DeleteCambioMoneda(cambioMoneda);
        }
    }
}
