﻿using LiquidacionGastos.Models;
using LiquidacionGastos.Repositories;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.UnitsOfWork
{
    public class DepartamentoUnitOfWork : EntityFrameworkTrackedUnitOfWork
    {
        private DepartamentoRepository DepartamentoRepository { get; set; }

        public DepartamentoUnitOfWork()
        {
        }

        public DepartamentoUnitOfWork(LGContext context) : base(context) 
        {            
        }

        protected override void OnInitializeRepositories()
        {
            this.DepartamentoRepository = new DepartamentoRepository(this.Context);
        }

        public override void OnTrackedChanged()
        {
            this.DepartamentoRepository.IsTrackingEnabled = this.IsTrackingEnabled;
        }

        public Departamento GetDepartamento(Guid idDepartamento)
        {
            if (idDepartamento == null)
                throw new ArgumentNullException("idDepartamento");

            return this.DepartamentoRepository.GetDepartamento(idDepartamento);
        }

        public void InsertDepartamento(Departamento departamento)
        {
            if (departamento == null)
                throw new ArgumentNullException("departamento");

            this.DepartamentoRepository.InsertDepartamento(departamento);
        }

        public void UpdateDepartamento(Departamento departamento)
        {
            if (departamento == null)
                throw new ArgumentNullException("departamento");

            this.DepartamentoRepository.UpdateDepartamento(departamento);
        }

        public void DeleteDepartamento(Departamento departamento)
        {
            if (departamento == null)
                throw new ArgumentNullException("departamento");

            this.DepartamentoRepository.DeleteDepartamento(departamento);
        }
    }
}
