﻿using LiquidacionGastos.Models;
using LiquidacionGastos.Repositories;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.UnitsOfWork
{
    public class EstadoLiquidacionUnitOfWork : EntityFrameworkTrackedUnitOfWork
    {
        private EstadoLiquidacionRepository EstadoLiquidacionRepository { get; set; }

        public EstadoLiquidacionUnitOfWork()
        {
        }

        public EstadoLiquidacionUnitOfWork(LGContext context) : base(context) 
        {            
        }

        protected override void OnInitializeRepositories()
        {
            this.EstadoLiquidacionRepository = new EstadoLiquidacionRepository(this.Context);
        }

        public override void OnTrackedChanged()
        {
            this.EstadoLiquidacionRepository.IsTrackingEnabled = this.IsTrackingEnabled;
        }

        public EstadoLiquidacion GetEstadoLiquidacion(int idEstadoLiquidacion)
        {
            return this.EstadoLiquidacionRepository.GetEstadoLiquidacion(idEstadoLiquidacion);
        }

        public void InsertEstadoLiquidacion(EstadoLiquidacion estadoLiquidacion)
        {
            if (estadoLiquidacion == null)
                throw new ArgumentNullException("estadoLiquidacion");

            this.EstadoLiquidacionRepository.InsertEstadoLiquidacion(estadoLiquidacion);
        }

        public void UpdateEstadoLiquidacion(EstadoLiquidacion estadoLiquidacion)
        {
            if (estadoLiquidacion == null)
                throw new ArgumentNullException("estadoLiquidacion");

            this.EstadoLiquidacionRepository.UpdateEstadoLiquidacion(estadoLiquidacion);
        }

        public void DeleteEstadoLiquidacion(EstadoLiquidacion estadoLiquidacion)
        {
            if (estadoLiquidacion == null)
                throw new ArgumentNullException("estadoLiquidacion");

            this.EstadoLiquidacionRepository.DeleteEstadoLiquidacion(estadoLiquidacion);
        }
    }
}
