﻿using LiquidacionGastos.Models;
using LiquidacionGastos.Repositories;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.UnitsOfWork
{
    public class GastoUnitOfWork : EntityFrameworkTrackedUnitOfWork
    {
        private GastoRepository GastoRepository { get; set; }

        public GastoUnitOfWork()
        {
        }

        public GastoUnitOfWork(LGContext context) : base(context) 
        {            
        }

        protected override void OnInitializeRepositories()
        {
            this.GastoRepository = new GastoRepository(this.Context);
        }

        public override void OnTrackedChanged()
        {
            this.GastoRepository.IsTrackingEnabled = this.IsTrackingEnabled;
        }

        public Gasto GetGasto(Guid idGasto)
        {
            if (idGasto == null)
                throw new ArgumentNullException("idGasto");

            return this.GastoRepository.GetGasto(idGasto);
        }

        public void InsertGasto(Gasto gasto)
        {
            if (gasto == null)
                throw new ArgumentNullException("gasto");

            this.GastoRepository.InsertGasto(gasto);
        }

        public void UpdateGasto(Gasto gasto)
        {
            if (gasto == null)
                throw new ArgumentNullException("gasto");

            this.GastoRepository.UpdateGasto(gasto);
        }

        public void DeleteGasto(Gasto gasto)
        {
            if (gasto == null)
                throw new ArgumentNullException("gasto");

            this.GastoRepository.DeleteGasto(gasto);
        }
    }
}
