﻿using LiquidacionGastos.Models;
using LiquidacionGastos.Repositories;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.UnitsOfWork
{
    public class MonedaUnitOfWork : EntityFrameworkTrackedUnitOfWork
    {
        private MonedaRepository MonedaRepository { get; set; }

        public MonedaUnitOfWork()
        {
        }

        public MonedaUnitOfWork(LGContext context) : base(context) 
        {            
        }

        protected override void OnInitializeRepositories()
        {
            this.MonedaRepository = new MonedaRepository(this.Context);
        }

        public override void OnTrackedChanged()
        {
            this.MonedaRepository.IsTrackingEnabled = this.IsTrackingEnabled;
        }

        public Moneda GetMoneda(int idMoneda)
        {
            return this.MonedaRepository.GetMoneda(idMoneda);
        }

        public void InsertMoneda(Moneda moneda)
        {
            if (moneda == null)
                throw new ArgumentNullException("moneda");

            this.MonedaRepository.InsertMoneda(moneda);
        }

        public void UpdateMoneda(Moneda moneda)
        {
            if (moneda == null)
                throw new ArgumentNullException("moneda");

            this.MonedaRepository.UpdateMoneda(moneda);
        }

        public void DeleteMoneda(Moneda moneda)
        {
            if (moneda == null)
                throw new ArgumentNullException("moneda");

            this.MonedaRepository.DeleteMoneda(moneda);
        }
    }
}
