﻿using LiquidacionGastos.Models;
using LiquidacionGastos.Repositories;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.UnitsOfWork
{
    public class NotificacionUnitOfWork : EntityFrameworkTrackedUnitOfWork
    {
        private NotificacionRepository NotificacionRepository { get; set; }

        public NotificacionUnitOfWork()
        {
        }

        public NotificacionUnitOfWork(LGContext context) : base(context) 
        {            
        }

        protected override void OnInitializeRepositories()
        {
            this.NotificacionRepository = new NotificacionRepository(this.Context);
        }

        public override void OnTrackedChanged()
        {
            this.NotificacionRepository.IsTrackingEnabled = this.IsTrackingEnabled;
        }

        public Notificacion GetNotificacion(Guid idNotificacion)
        {
            if (idNotificacion == null)
                throw new ArgumentNullException("idNotificacion");

            return this.NotificacionRepository.GetNotificacion(idNotificacion);
        }

        public void InsertNotificacion(Notificacion notificacion)
        {
            if (notificacion == null)
                throw new ArgumentNullException("notificacion");

            this.NotificacionRepository.InsertNotificacion(notificacion);
        }

        public void UpdateNotificacion(Notificacion notificacion)
        {
            if (notificacion == null)
                throw new ArgumentNullException("notificacion");

            this.NotificacionRepository.UpdateNotificacion(notificacion);
        }

        public void DeleteNotificacion(Notificacion notificacion)
        {
            if (notificacion == null)
                throw new ArgumentNullException("notificacion");

            this.NotificacionRepository.DeleteNotificacion(notificacion);
        }
    }
}
