﻿using LiquidacionGastos.Models;
using LiquidacionGastos.Repositories;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.UnitsOfWork
{
    public class TipoGastoUnitOfWork : EntityFrameworkTrackedUnitOfWork
    {
        private TipoGastoRepository TipoGastoRepository { get; set; }

        public TipoGastoUnitOfWork()
        {
        }

        public TipoGastoUnitOfWork(LGContext context) : base(context) 
        {            
        }

        protected override void OnInitializeRepositories()
        {
            this.TipoGastoRepository = new TipoGastoRepository(this.Context);
        }

        public override void OnTrackedChanged()
        {
            this.TipoGastoRepository.IsTrackingEnabled = this.IsTrackingEnabled;
        }

        public TipoGasto GetTipoGasto(int idTipoGasto)
        {
            return this.TipoGastoRepository.GetTipoGasto(idTipoGasto);
        }

        public void InsertTipoGasto(TipoGasto tipoGasto)
        {
            if (tipoGasto == null)
                throw new ArgumentNullException("tipoGasto");

            this.TipoGastoRepository.InsertTipoGasto(tipoGasto);
        }

        public void UpdateTipoGasto(TipoGasto tipoGasto)
        {
            if (tipoGasto == null)
                throw new ArgumentNullException("tipoGasto");

            this.TipoGastoRepository.UpdateTipoGasto(tipoGasto);
        }

        public void DeleteTipoGasto(TipoGasto tipoGasto)
        {
            if (tipoGasto == null)
                throw new ArgumentNullException("tipoGasto");

            this.TipoGastoRepository.DeleteTipoGasto(tipoGasto);
        }
    }
}
