﻿using LiquidacionGastos.Models;
using LiquidacionGastos.Repositories;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.UnitsOfWork
{
    public class UsuarioUnitOfWork : EntityFrameworkTrackedUnitOfWork
    {
        private UsuarioRepository UsuarioRepository { get; set; }

        public UsuarioUnitOfWork()
        {
        }

        public UsuarioUnitOfWork(LGContext context) : base(context) 
        {            
        }

        protected override void OnInitializeRepositories()
        {
            this.UsuarioRepository = new UsuarioRepository(this.Context);
        }

        public override void OnTrackedChanged()
        {
            this.UsuarioRepository.IsTrackingEnabled = this.IsTrackingEnabled;
        }

        public Usuario GetUsuario(Guid idUsuario)
        {
            if (idUsuario == null)
                throw new ArgumentNullException("idUsuario");

            return this.UsuarioRepository.GetUsuario(idUsuario);
        }

        public void InsertUsuario(Usuario usuario)
        {
            if (usuario == null)
                throw new ArgumentNullException("usuario");

            this.UsuarioRepository.InsertUsuario(usuario);
        }

        public void UpdateUsuario(Usuario usuario)
        {
            if (usuario == null)
                throw new ArgumentNullException("usuario");

            this.UsuarioRepository.UpdateUsuario(usuario);
        }

        public void DeleteUsuario(Usuario usuario)
        {
            if (usuario == null)
                throw new ArgumentNullException("usuario");

            this.UsuarioRepository.DeleteUsuario(usuario);
        }
    }
}
