﻿using LiquidacionGastos.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.WebServiceRepositories
{
    public class EntitySyncWebServiceRepository : WebServiceRespository
    {
        private EntitySyncWebService.IEntitySyncService EntitySyncWebService{ get; set; }

        public EntitySyncWebServiceRepository()
        {            
        }

        protected override void OnInitialize()
        {
            this.EntitySyncWebService = new EntitySyncWebService.EntitySyncServiceClient();
        }

        public Calendario GetCalendario(Guid idCalendario)
        {
            return this.EntitySyncWebService.GetCalendario(idCalendario);
        }

        public void InsertCalendario(Calendario calendario)
        {
            this.EntitySyncWebService.InsertCalendario(calendario);
        }

        public void UpdateCalendario(Calendario calendario)
        {
            this.EntitySyncWebService.UpdateCalendario(calendario);
        }

        public void DeleteCalendario(Calendario calendario)
        {
            this.EntitySyncWebService.DeleteCalendario(calendario);
        }

        public Departamento GetDepartamento(Guid idDepartamento)
        {
            return this.EntitySyncWebService.GetDepartamento(idDepartamento);
        }

        public void InsertDepartamento(Departamento departamento)
        {
            this.EntitySyncWebService.InsertDepartamento(departamento);
        }

        public void UpdateDepartamento(Departamento departamento)
        {
            this.EntitySyncWebService.UpdateDepartamento(departamento);
        }

        public void DeleteDepartamento(Departamento departamento)
        {
            this.EntitySyncWebService.DeleteDepartamento(departamento);
        }

        public Moneda GetMoneda(int idMoneda)
        {
            return this.EntitySyncWebService.GetMoneda(idMoneda);
        }

        public void InsertMoneda(Moneda moneda)
        {
            this.EntitySyncWebService.InsertMoneda(moneda);
        }

        public void UpdateMoneda(Moneda moneda)
        {
            this.EntitySyncWebService.UpdateMoneda(moneda);
        }

        public void DeleteMoneda(Moneda moneda)
        {
            this.EntitySyncWebService.DeleteMoneda(moneda);
        }

        public TipoGasto GetTipoGasto(int idTipoGasto)
        {
            return this.EntitySyncWebService.GetTipoGasto(idTipoGasto);
        }

        public void InsertTipoGasto(TipoGasto tipoGasto)
        {
            this.EntitySyncWebService.InsertTipoGasto(tipoGasto);
        }

        public void UpdateTipoGasto(TipoGasto tipoGasto)
        {
            this.EntitySyncWebService.UpdateTipoGasto(tipoGasto);
        }

        public void DeleteTipoGasto(TipoGasto tipoGasto)
        {
            this.EntitySyncWebService.DeleteTipoGasto(tipoGasto);
        }

        public EstadoLiquidacion GetEstadoLiquidacion(int idEstadoLiquidacion)
        {
            return this.EntitySyncWebService.GetEstadoLiquidacion(idEstadoLiquidacion);
        }

        public void InsertEstadoLiquidacion(EstadoLiquidacion estadoLiquidacion)
        {
            this.EntitySyncWebService.InsertEstadoLiquidacion(estadoLiquidacion);
        }

        public void UpdateEstadoLiquidacion(EstadoLiquidacion estadoLiquidacion)
        {
            this.EntitySyncWebService.UpdateEstadoLiquidacion(estadoLiquidacion);
        }

        public void DeleteEstadoLiquidacion(EstadoLiquidacion estadoLiquidacion)
        {
            this.EntitySyncWebService.DeleteEstadoLiquidacion(estadoLiquidacion);
        }

        public Usuario GetUsuario(Guid idUsuario)
        {
            return this.EntitySyncWebService.GetUsuario(idUsuario);
        }

        public void InsertUsuario(Usuario usuario)
        {
            this.EntitySyncWebService.InsertUsuario(usuario);
        }

        public void UpdateUsuario(Usuario usuario)
        {
            this.EntitySyncWebService.UpdateUsuario(usuario);
        }

        public void DeleteUsuario(Usuario usuario)
        {
            this.EntitySyncWebService.DeleteUsuario(usuario);
        }

        public CambioMoneda GetCambioMoneda(Guid idCambioMoneda)
        {
            return this.EntitySyncWebService.GetCambioMoneda(idCambioMoneda);
        }

        public void InsertCambioMoneda(CambioMoneda cambioMoneda)
        {
            this.EntitySyncWebService.InsertCambioMoneda(cambioMoneda);
        }

        public void UpdateCambioMoneda(CambioMoneda cambioMoneda)
        {
            this.EntitySyncWebService.UpdateCambioMoneda(cambioMoneda);
        }

        public void DeleteCambioMoneda(CambioMoneda cambioMoneda)
        {
            this.EntitySyncWebService.DeleteCambioMoneda(cambioMoneda);
        }

        public Liquidacion GetLiquidacion(Guid idLiquidacion)
        {
            return this.EntitySyncWebService.GetLiquidacion(idLiquidacion);
        }

        public void InsertLiquidacion(Liquidacion liquidacion)
        {
            this.EntitySyncWebService.InsertLiquidacion(liquidacion);
        }

        public void UpdateLiquidacion(Liquidacion liquidacion)
        {
            this.EntitySyncWebService.UpdateLiquidacion(liquidacion);
        }

        public void DeleteLiquidacion(Liquidacion liquidacion)
        {
            this.EntitySyncWebService.DeleteLiquidacion(liquidacion);
        }

        public Gasto GetGasto(Guid idGasto)
        {
            return this.EntitySyncWebService.GetGasto(idGasto);
        }

        public void InsertGasto(Gasto gasto)
        {
            this.EntitySyncWebService.InsertGasto(gasto);
        }

        public void UpdateGasto(Gasto gasto)
        {
            this.EntitySyncWebService.UpdateGasto(gasto);
        }

        public void DeleteGasto(Gasto gasto)
        {
            this.EntitySyncWebService.DeleteGasto(gasto);
        }

        public CambioEstadoLiquidacion GetCambioEstadoLiquidacion(Guid idCambioEstadoLiquidacion)
        {
            return this.EntitySyncWebService.GetCambioEstadoLiquidacion(idCambioEstadoLiquidacion);
        }

        public void InsertCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion)
        {
            this.EntitySyncWebService.InsertCambioEstadoLiquidacion(cambioEstadoLiquidacion);
        }

        public void UpdateCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion)
        {
            this.EntitySyncWebService.UpdateCambioEstadoLiquidacion(cambioEstadoLiquidacion);
        }

        public void DeleteCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion)
        {
            this.EntitySyncWebService.DeleteCambioEstadoLiquidacion(cambioEstadoLiquidacion);
        }

        public Notificacion GetNotificacion(Guid idNotificacion)
        {
            return this.EntitySyncWebService.GetNotificacion(idNotificacion);
        }

        public void InsertNotificacion(Notificacion notificacion)
        {
            this.EntitySyncWebService.InsertNotificacion(notificacion);
        }

        public void UpdateNotificacion(Notificacion notificacion)
        {
            this.EntitySyncWebService.UpdateNotificacion(notificacion);
        }

        public void DeleteNotificacion(Notificacion notificacion)
        {
            this.EntitySyncWebService.DeleteNotificacion(notificacion);
        }

    }
}
