﻿using LiquidacionGastos.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastos.WebServiceRepositories
{
    public class TrackingEntryWebServiceRepository : WebServiceRespository
    {
        private TrackingWebService.ITrackingService TrackingWebService{ get; set; }

        public TrackingEntryWebServiceRepository()
        {            
        }

        protected override void OnInitialize()
        {
            this.TrackingWebService = new TrackingWebService.TrackingServiceClient();
        }

        public TrackingEntry GetTrackingEntry(Guid idTrackingEntry)
        {
            return this.TrackingWebService.GetTrackingEntry(idTrackingEntry);
        }

        public IList<TrackingEntry> ListTrackingEntries(DateTime dateFrom)
        {
            return this.TrackingWebService.ListTrackingEntries(dateFrom);
        }

        public void InsertTrackingEntry(TrackingEntry trackingEntry)
        {
            this.TrackingWebService.InsertTrackingEntry(trackingEntry);
        }

        public void UpdateTrackingEntry(TrackingEntry trackingEntry)
        {
            this.TrackingWebService.UpdateTrackingEntry(trackingEntry);
        }

        public void DeleteTrackingEntry(TrackingEntry trackingEntry)
        {
            this.TrackingWebService.DeleteTrackingEntry(trackingEntry);
        }
    }
}
