﻿using LiquidacionGastos.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastosService.Contracts
{
    [ServiceContract]
    public interface IEntitySyncService
    {
        #region [Entidad Calendario]

        [OperationContract]
        [WebInvoke(UriTemplate = "/Calendario/Get/{idCalendario}", Method = "GET")]
        Calendario GetCalendario(Guid idCalendario);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Calendario/Insert/{calendario}", Method = "POST")]
        void InsertCalendario(Calendario calendario);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Calendario/Update/{calendario}", Method = "PUT")]
        void UpdateCalendario(Calendario calendario);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Calendario/Delete/{calendario}", Method = "DELETE")]
        void DeleteCalendario(Calendario calendario);

        #endregion [Entidad Calendario]

        #region [Entidad Departamento]

        [OperationContract]
        [WebInvoke(UriTemplate = "/Departamento/Get/{idDepartamento}", Method = "GET")]
        Departamento GetDepartamento(Guid idDepartamento);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Departamento/Insert/{departamento}", Method = "POST")]
        void InsertDepartamento(Departamento departamento);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Departamento/Update/{departamento}", Method = "PUT")]
        void UpdateDepartamento(Departamento departamento);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Departamento/Delete/{departamento}", Method = "DELETE")]
        void DeleteDepartamento(Departamento departamento);

        #endregion [Entidad Departamento]

        #region [Entidad Moneda]

        [OperationContract]
        [WebInvoke(UriTemplate = "/Moneda/Get/{idMoneda}", Method = "GET")]
        Moneda GetMoneda(int idMoneda);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Moneda/Insert/{moneda}", Method = "POST")]
        void InsertMoneda(Moneda moneda);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Moneda/Update/{moneda}", Method = "PUT")]
        void UpdateMoneda(Moneda moneda);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Moneda/Delete/{moneda}", Method = "DELETE")]
        void DeleteMoneda(Moneda moneda);

        #endregion [Entidad Moneda]

        #region [Entidad TipoGasto]

        [OperationContract]
        [WebInvoke(UriTemplate = "/TipoGasto/Get/{idTipoGasto}", Method = "GET")]
        TipoGasto GetTipoGasto(int idTipoGasto);

        [OperationContract]
        [WebInvoke(UriTemplate = "/TipoGasto/Insert/{tipoGasto}", Method = "POST")]
        void InsertTipoGasto(TipoGasto tipoGasto);

        [OperationContract]
        [WebInvoke(UriTemplate = "/TipoGasto/Update/{tipoGasto}", Method = "PUT")]
        void UpdateTipoGasto(TipoGasto tipoGasto);

        [OperationContract]
        [WebInvoke(UriTemplate = "/TipoGasto/Delete/{tipoGasto}", Method = "DELETE")]
        void DeleteTipoGasto(TipoGasto tipoGasto);

        #endregion [Entidad TipoGasto]

        #region [Entidad EstadoLiquidacion]

        [OperationContract]
        [WebInvoke(UriTemplate = "/EstadoLiquidacion/Get/{idEstadoLiquidacion}", Method = "GET")]
        EstadoLiquidacion GetEstadoLiquidacion(int idEstadoLiquidacion);

        [OperationContract]
        [WebInvoke(UriTemplate = "/EstadoLiquidacion/Insert/{estadoLiquidacion}", Method = "POST")]
        void InsertEstadoLiquidacion(EstadoLiquidacion estadoLiquidacion);

        [OperationContract]
        [WebInvoke(UriTemplate = "/EstadoLiquidacion/Update/{estadoLiquidacion}", Method = "PUT")]
        void UpdateEstadoLiquidacion(EstadoLiquidacion estadoLiquidacion);

        [OperationContract]
        [WebInvoke(UriTemplate = "/EstadoLiquidacion/Delete/{estadoLiquidacion}", Method = "DELETE")]
        void DeleteEstadoLiquidacion(EstadoLiquidacion estadoLiquidacion);

        #endregion [Entidad EstadoLiquidacion]

        #region [Entidad Usuario]

        [OperationContract]
        [WebInvoke(UriTemplate = "/Usuario/Get/{idUsuario}", Method = "GET")]
        Usuario GetUsuario(Guid idUsuario);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Usuario/Insert/{usuario}", Method = "POST")]
        void InsertUsuario(Usuario usuario);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Usuario/Update/{usuario}", Method = "PUT")]
        void UpdateUsuario(Usuario usuario);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Usuario/Delete/{usuario}", Method = "DELETE")]
        void DeleteUsuario(Usuario usuario);

        #endregion [Entidad Usuario]

        #region [Entidad CambioMoneda]

        [OperationContract]
        [WebInvoke(UriTemplate = "/CambioMoneda/Get/{idCambioMoneda}", Method = "GET")]
        CambioMoneda GetCambioMoneda(Guid idCambioMoneda);

        [OperationContract]
        [WebInvoke(UriTemplate = "/CambioMoneda/Insert/{cambioMoneda}", Method = "POST")]
        void InsertCambioMoneda(CambioMoneda cambioMoneda);

        [OperationContract]
        [WebInvoke(UriTemplate = "/CambioMoneda/Update/{cambioMoneda}", Method = "PUT")]
        void UpdateCambioMoneda(CambioMoneda cambioMoneda);

        [OperationContract]
        [WebInvoke(UriTemplate = "/CambioMoneda/Delete/{cambioMoneda}", Method = "DELETE")]
        void DeleteCambioMoneda(CambioMoneda cambioMoneda);

        #endregion [Entidad CambioMoneda]

        #region [Entidad Liquidacion]

        [OperationContract]
        [WebInvoke(UriTemplate = "/Liquidacion/Get/{idLiquidacion}", Method = "GET")]
        Liquidacion GetLiquidacion(Guid idLiquidacion);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Liquidacion/Insert/{liquidacion}", Method = "POST")]
        void InsertLiquidacion(Liquidacion liquidacion);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Liquidacion/Update/{liquidacion}", Method = "PUT")]
        void UpdateLiquidacion(Liquidacion liquidacion);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Liquidacion/Delete/{liquidacion}", Method = "DELETE")]
        void DeleteLiquidacion(Liquidacion liquidacion);

        #endregion [Entidad Liquidacion]

        #region [Entidad Gasto]

        [OperationContract]
        [WebInvoke(UriTemplate = "/Gasto/Get/{idGasto}", Method = "GET")]
        Gasto GetGasto(Guid idGasto);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Gasto/Insert/{gasto}", Method = "POST")]
        void InsertGasto(Gasto gasto);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Gasto/Update/{gasto}", Method = "PUT")]
        void UpdateGasto(Gasto gasto);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Gasto/Delete/{gasto}", Method = "DELETE")]
        void DeleteGasto(Gasto gasto);

        #endregion [Entidad Gasto]

        #region [Entidad CambioEstadoLiquidacion]

        [OperationContract]
        [WebInvoke(UriTemplate = "/CambioEstadoLiquidacion/Get/{idCambioEstadoLiquidacion}", Method = "GET")]
        CambioEstadoLiquidacion GetCambioEstadoLiquidacion(Guid idCambioEstadoLiquidacion);

        [OperationContract]
        [WebInvoke(UriTemplate = "/CambioEstadoLiquidacion/Insert/{cambioEstadoLiquidacion}", Method = "POST")]
        void InsertCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion);

        [OperationContract]
        [WebInvoke(UriTemplate = "/CambioEstadoLiquidacion/Update/{cambioEstadoLiquidacion}", Method = "PUT")]
        void UpdateCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion);

        [OperationContract]
        [WebInvoke(UriTemplate = "/CambioEstadoLiquidacion/Delete/{cambioEstadoLiquidacion}", Method = "DELETE")]
        void DeleteCambioEstadoLiquidacion(CambioEstadoLiquidacion cambioEstadoLiquidacion);

        #endregion [Entidad CambioEstadoLiquidacion]

        #region [Entidad Notificacion]

        [OperationContract]
        [WebInvoke(UriTemplate = "/Notificacion/Get/{idNotificacion}", Method = "GET")]
        Notificacion GetNotificacion(Guid idNotificacion);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Notificacion/Insert/{notificacion}", Method = "POST")]
        void InsertNotificacion(Notificacion notificacion);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Notificacion/Update/{notificacion}", Method = "PUT")]
        void UpdateNotificacion(Notificacion notificacion);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Notificacion/Delete/{notificacion}", Method = "DELETE")]
        void DeleteNotificacion(Notificacion notificacion);

        #endregion [Entidad Notificacion]
    }
}
