﻿using LiquidacionGastos.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastosService.Contracts
{
    [ServiceContract]
    public interface ITrackingService
    {
        [OperationContract]
        [WebInvoke(UriTemplate = "/Tracking/Get/{idTrackingEntry}", Method = "GET")]
        TrackingEntry GetTrackingEntry(Guid idTrackingEntry);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Tracking/List/{dateFrom}", Method = "GET")]
        IList<TrackingEntry> ListTrackingEntries(DateTime dateFrom);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Tracking/Insert/{trackingEntry}", Method = "POST")]
        void InsertTrackingEntry(TrackingEntry trackingEntry);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Tracking/Update/{trackingEntry}", Method = "PUT")]
        void UpdateTrackingEntry(TrackingEntry trackingEntry);

        [OperationContract]
        [WebInvoke(UriTemplate = "/Tracking/Delete/{trackingEntry}", Method = "DELETE")]
        void DeleteTrackingEntry(TrackingEntry trackingEntry);        
    }
}
