﻿using LiquidacionGastos.Business;
using LiquidacionGastos.Models;
using LiquidacionGastos.Repositories;
using LiquidacionGastos.UnitsOfWork;
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastosService
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.Write("Comprobando base de datos:");

            // Chequear si existen los tipos básicos y de otro modos crearlos.
            ICollection<TipoGasto> l = MasterTypeFactory.ListTiposGasto();
            if (l.Count() == 0)
            {
                MasterTypeManagement m = new MasterTypeManagement();
                m.CreateMasterTypes();
            }

            Console.WriteLine("ok");

            IList<ServiceHost> serviceHosts = new List<ServiceHost>();
            serviceHosts.Add(new ServiceHost(typeof(Services.AuthenticationService)));
            serviceHosts.Add(new ServiceHost(typeof(Services.TimeSyncService)));
            serviceHosts.Add(new ServiceHost(typeof(Services.TrackingService)));
            serviceHosts.Add(new ServiceHost(typeof(Services.EntitySyncService)));

            // Open the ServiceHost to create listeners and start listening for messages.
            foreach (ServiceHost sh in serviceHosts)
            {
                Console.WriteLine("Servicio {0}: Abierto", sh.Description.Name);
                sh.Open();
            }

            Console.WriteLine("Servicios en ejecución.");
            Console.WriteLine();
            Console.ReadLine();

            // Close the ServiceHosts
            foreach (ServiceHost sh in serviceHosts)
            {
                Console.WriteLine("Servicio {0}: Cerrado", sh.Description.Name);
                sh.Close();
            }
        }
    }
}
