﻿using LiquidacionGastos.Models;
using LiquidacionGastos.UnitsOfWork;
using LiquidacionGastosService.Contracts;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LiquidacionGastosService.Services
{
    public class TrackingService : ITrackingService
    {
        public TrackingEntry GetTrackingEntry(Guid idTrackingEntry)
        {
            Debug.WriteLine(string.Format("Servidor: Petición de entrada de seguimiento con ID {0}", idTrackingEntry.ToString()));
            using (TrackingUnitOfWork uow = new TrackingUnitOfWork())
            {
                return uow.GetTrackingEntry(idTrackingEntry);
            }
        }

        public IList<TrackingEntry> ListTrackingEntries(DateTime dateFrom)
        {
            Debug.WriteLine(string.Format("Servidor: Petición de entradas de seguimiento desde {0}", dateFrom.ToShortDateString()));
            using (TrackingUnitOfWork uow = new TrackingUnitOfWork())
            {
                return uow.ListTrackingEntries(dateFrom);
            }
        }

        public void InsertTrackingEntry(TrackingEntry trackingEntry)
        {
            Debug.WriteLine(string.Format("Servidor: Inserción de entrada de seguimiento con ID {0}", trackingEntry.IdTracking.ToString()));
            using (TrackingUnitOfWork uow = new TrackingUnitOfWork())
            {
                uow.InsertTrackingEntry(trackingEntry);
                uow.Commit();
            }
        }

        public void UpdateTrackingEntry(TrackingEntry trackingEntry)
        {
            Debug.WriteLine(string.Format("Servidor: Actualización de entrada de seguimiento con ID {0}", trackingEntry.IdTracking.ToString()));
            using (TrackingUnitOfWork uow = new TrackingUnitOfWork())
            {
                uow.UpdateTrackingEntry(trackingEntry);
                uow.Commit();
            }
        }

        public void DeleteTrackingEntry(TrackingEntry trackingEntry)
        {
            Debug.WriteLine(string.Format("Servidor: Borrado de entrada de seguimiento con ID {0}", trackingEntry.IdTracking.ToString()));
            using (TrackingUnitOfWork uow = new TrackingUnitOfWork())
            {
                uow.DeleteTrackingEntry(trackingEntry);
                uow.Commit();
            }
        }
    }
}
